.\"	@(#) $Header: kgdbtunnel.man,v 1.1 96/01/14 23:54:04 leres Exp $ (LBL)
.TH kgdbtunnel 8 "Jan 14, 1996"
.UC 4
.SH NAME
kgdbtunnel - tunnel a kgdb kernel debugging session
.SH SYNOPSIS
.B kgdbtunnel
.RB [ -dkpv ]
.RB [ -s
.IR speed ]
.IR hostname [ :port ]
.RI [ tty ]
.SH DESCRIPTION
.B Kgdbtunnel
uses tcp/ip to tunnel a serial port for a kgdb kernel debugging
session. This makes it possible to kernel debugging between two hosts
that are not physically close enough to run a serial line between them.

.LP
.I Hostname
is the name or raw ip address of the host that will
serve as the other end of the tunnel.

.LP
.I Port
is the optional tcp port (which defaults to 4040).

.LP
.I Tty
is the optional terminal name
(which defaults to
.IR /dev/kgdb ).

.LP
.SH OPTIONS

.TP
.B -d
Produce debugging output.

.TP
.B -k
Create a symlink from
.I tty
(which defaults to
.IR /dev/kgdb )
to the pseudo terminal.
Implies 
.BR -p .

.TP
.B -v
Produce verbose output.

.TP
.B -p
Create a pseudo terminal (pty) instead of opening a real tty.

.TP
.B -s
Specify the
.I tty
speed. The default is 38400.

.LP
A typical debugging session would proceed as follows:

.TP
\ \ \ \(bu
A serial cable is connected between the debug host and
the first
.B kgdbtunnel
host.

.TP
\ \ \ \(bu
Kernel
.B gdb
debugging is enabled on the debug host

.TP
\ \ \ \(bu
The first host runs
.RB `` kgdbtunnel
.IR hosttwo ''

.TP
\ \ \ \(bu
The second host runs
.RB `` kgdbtunnel
.B -k
.IR hostone ''

.TP
\ \ \ \(bu
The second host runs
.B gdb

.TP
\ \ \ \(bu
The second host attaches with ``target remote kgdb''

.LP
In this example, it is assumed that
.I /dev/kgdb
is a symlink that points to serial port used by
the first host. And the second host uses
.BR -k
to create a symlink from
.I /dev/kgdb
to the newly created pty.
Notice that the machine that runs
.B gdb
does not need to talk to an actual serial port.

.LP
The order in which the debug hosts start
.B kgdbtunnel
is not important; when the first end starts up, it detects that the
other end isn't listening yet so it does.


.LP
.SH FILES
.na
.nh
.nf
/dev/kgdb - default tty
/dev/pty* - pseudo terminals
.ad
.hy
.fi
.LP
.SH "SEE ALSO"
.na
.nh
gdb(1)
.ad
.hy
.SH BUGS
There's a race when starting up; both ends can end up waiting
for each other. If this happens, 
.B ^C
and restart one end.

.LP
availability of the
.BR -k and -p
flags depend on the
.BR openpty ()
library routine.

.LP
This program is only known to build and operate under BSD/OS 2 and
SunOS 4.
